//**********************************************************************************************************
//Instuctions:

//Place LocalMsgBxDlg1 in uses
//Copy LocalMsgBxDlg1.pas and LocalMsgBxDlg1.dfm (not LocalMsgBxDlg1.dcu) to needed folder.
//Go to IDE menu item 'Project'/'Add to project' and add LocalMsgBxDlg1

//Change warning message
//MsgBxDlg1.CentralMsgBxLabelLabelWarning.Caption := 'Setup mixnym';

// Button captions
//1. LocalMsgBxDlg1.ButtonParams('OK', 'Cancel');  //change double button caption param
//2. LocalMsgBxDlg1.ButtonParams('OK', '');               //change single button caption param

// Message box background and font colors:
// LocalMsgBxDlg1.MsgBoxParams(clYellow, clRed);  //change msg box param (1=bkg, 2=font color)

//'C>Message...' = do not wrap
//'C*Message...' = center msg

// LocalMsgBxDlg1.CentralMessagesRtn(1, 'Message...');  // 1 = OK;  2 = OK/Cancel;          'C>Message...' = do not wrap
// LocalMsgBxDlg1.CentralMessagesRtn(2, 'Message...');  // 2 = OK/Cancel;                   'C*Message...' = center msg
// LocalMsgBxDlg1.CentralMessagesRtn(1, 'My message line1' + #13#10 + 'My message line2');  Force line wrap

//Check results using these:
//     if LocalMsgBxDlg1.CentralMessagesRtn(2, 'C*My message 1.') = True then    // OK = True; Cancel = False
//        Label1.Caption := ('OK pressed')
//        else
//        Label1.Caption := ('Cancel pressed');
//**********************************************************************************************************

unit LocalMsgBxDlgUnit1;

{$MODE Delphi}
////{$mode objfpc}{$H+}

interface

uses
    Windows, Classes, SysUtils, FileUtil, BGRAButton, Forms,
    Controls, Graphics, ExtCtrls, StdCtrls;

type

  { TLocalMsgBxDlg1 }

  TLocalMsgBxDlg1 = class(TForm)
    CentralMsgBxButtonOK: TBGRAButton;
    CentralMsgBxButtonCancel: TBGRAButton;
    CentralMsgBxButtonOK2: TBGRAButton;
    CentralMsgBxLabel: TLabel;
    CentralMsgBxLabelLabelWarning: TLabel;
    CentralMsgBxLabelPanel1: TPanel;
    CentralMsgBxLabelPanel2: TPanel;
    Image3: TImage;
    OkCancelPanel: TPanel;
    OkPanel: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;

    procedure CentralMsgBxButtonCancelClick(Sender: TObject);
    procedure CentralMsgBxButtonOK2Click(Sender: TObject);
    procedure CentralMsgBxButtonOKClick(Sender: TObject);
    procedure CentralMsgBxLabelPanel2MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

    function ButtonParams(OKBtnNm, CNBtnNm: string): boolean;
    function CentralMessagesRtn(OkCancelOrOkBtn1: integer; MessageLn1: string): boolean;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
    function ResetBxBtn: boolean;

  private
    { private declarations }
  public
    { public declarations }
  end;

var
  LocalMsgBxDlg1: TLocalMsgBxDlg1;
    LMRsw1: integer = 0;
    SaveResult : string;
    OkCancelOrOkBtn: integer;
    MessageLn: string;

implementation

{$R *.frm}
uses unit1;

{ TLocalMsgBxDlg1 }

//CenterMouse rtn
function CenterMouse(Control: TControl; FromLeft, FromTop : integer): boolean;
var Center: TPoint;
begin
     Center := Control.ClientOrigin;
     Inc(Center.X, Control.ClientWidth  div 2);
     Inc(Center.Y, Control.ClientHeight div 2);
     Inc(Center.X, FromLeft);
     Inc(Center.Y, FromTop);
     Mouse.CursorPos := Center;

     Result := True;
//     CenterMouse(Button1, 0, 0);
end;

//Reset button captions
function TLocalMsgBxDlg1.ResetBxBtn: boolean;
begin
     CentralMsgBxButtonOK.Caption := 'OK';
     CentralMsgBxButtonOK2.Caption := 'OK';
     CentralMsgBxButtonCancel.Caption := 'Cancel';

     CentralMsgBxButtonOK.Repaint;
     CentralMsgBxButtonOK2.Repaint;
     CentralMsgBxButtonCancel.Repaint;
     Result := True;
end;

//Button captions
function TLocalMsgBxDlg1.ButtonParams(OKBtnNm, CNBtnNm: string): boolean;
begin
     Result := True;

     CentralMsgBxButtonOK.Caption := OKBtnNm;
     CentralMsgBxButtonOK2.Caption := OKBtnNm;
     CentralMsgBxButtonCancel.Caption := CNBtnNm;
end;

function TLocalMsgBxDlg1.CentralMessagesRtn(OkCancelOrOkBtn1: integer; MessageLn1: string): boolean;
begin
     OkCancelOrOkBtn := OkCancelOrOkBtn1;
     MessageLn := MessageLn1;
     //form now adjusted in Form.Show

     LMRsw1 := 0;
     LocalMsgBxDlg1.Show;
     CentralMsgBxLabelPanel1.Repaint;
     CentralMsgBxLabelPanel2.Repaint;
     Application.ProcessMessages;

     CenterMouse(OkCancelPanel, 0, 0);

     while LMRsw1 = 0 do begin
       sleep(100);
       Application.ProcessMessages;
       if Application.Terminated then
          abort;
     end;

     if LMRsw1 = 1 then
        Result := True             //OK pressed
        else
        Result := False;           //Cancel pressed

     LocalMsgBxDlg1.Close;
     ResetBxBtn;
end;

procedure TLocalMsgBxDlg1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
     CentralMsgBxLabelLabelWarning.Caption := 'Warning';
end;

procedure TLocalMsgBxDlg1.FormShow(Sender: TObject);
begin
     try
       CentralMsgBxLabel.Alignment := taLeftJustify;
     except
     end;

     if (copy(MessageLn, 1, 2) = 'C>') or (copy(MessageLn, 1, 2) = 'C*') then begin
        if copy(MessageLn, 1, 2) = 'C*' then
           CentralMsgBxLabel.Alignment := taCenter;

        CentralMsgBxLabel.Constraints.MaxWidth := 0;
        CentralMsgBxLabel.Constraints.MaxWidth := 0;
        CentralMsgBxLabel.WordWrap := False;
        CentralMsgBxLabel.Caption := copy(MessageLn, 3, 255); // get around C> and C*
        CentralMsgBxLabel.Refresh;
        CentralMsgBxLabelPanel1.Width := CentralMsgBxLabel.Width + 25; //was 27
        CentralMsgBxLabelPanel2.Width := CentralMsgBxLabel.Width + 18; //was 20
        LocalMsgBxDlg1.Width := CentralMsgBxLabelPanel1.Width - 1;
        end
        else begin
        CentralMsgBxLabel.Constraints.MaxWidth := 281;
        CentralMsgBxLabel.Constraints.MaxWidth := 281;
        CentralMsgBxLabelPanel1.Width := 310;   //set back to origional width
        CentralMsgBxLabelPanel2.Width := 303;   //set back to origional width
        CentralMsgBxLabel.WordWrap := True;
        CentralMsgBxLabel.Refresh;
        CentralMsgBxLabel.Caption := copy(MessageLn, 1, 255);
        LocalMsgBxDlg1.Width := CentralMsgBxLabelPanel1.Width - 1;

        if copy(MessageLn, 1, 2) = 'C*' then begin
           CentralMsgBxLabel.Caption := copy(MessageLn, 3, 255); // get around C*
           CentralMsgBxLabel.Alignment := taCenter;
           end;
        end;

     CentralMsgBxLabelPanel2.Height := CentralMsgBxLabel.Height + 80;
     OkCancelPanel.Top := CentralMsgBxLabelPanel2.Height  - 27;
     OkPanel.Top := CentralMsgBxLabelPanel2.Height  - 27;
     CentralMsgBxLabelPanel1.Height := CentralMsgBxLabelPanel2.Height + 7;
     LocalMsgBxDlg1.Height := CentralMsgBxLabelPanel1.Height - 1;

     LocalMsgBxDlg1.Top  := (Screen.Height div 2) - (LocalMsgBxDlg1.Height div 2);
     LocalMsgBxDlg1.Left := (Screen.Width div 2) - (LocalMsgBxDlg1.Width div 2);
     LocalMsgBxDlg1.Top  := (Form1.Top) + ((Form1.Height div 2) - (LocalMsgBxDlg1.Height div 2));
     LocalMsgBxDlg1.Left := (Form1.Left) + ((Form1.Width div 2) - (LocalMsgBxDlg1.Width div 2));
     OkPanel.Left := abs((CentralMsgBxLabelPanel2.Width div 2) - (OkPanel.Width div 2));
     OkCancelPanel.Left := ((CentralMsgBxLabelPanel2.Width div 2) - (OkCancelPanel.Width div 2));

     case OkCancelOrOkBtn of                   // 1 = OK; 2 = OK/Cancel, 21 = OK/Cancel MsgBox
          1 : begin
              OkCancelPanel.Visible := False;  // btns on panal bcse will not go invisible
              OkPanel.Visible := True;
              end;
          2 : begin
              OkCancelPanel.Visible := True;
              OkPanel.Visible := True;
              end;
     end;
end;

procedure TLocalMsgBxDlg1.CentralMsgBxLabelPanel2MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     ReleaseCapture;
     SendMessage(LocalMsgBxDlg1.Handle, WM_SYSCOMMAND, 61458, 0) ;
end;

//OK button (with Cancel)
procedure TLocalMsgBxDlg1.CentralMsgBxButtonOKClick(Sender: TObject);
begin
     LMRsw1 := 1;
end;

//Cancel button (with OK)
procedure TLocalMsgBxDlg1.CentralMsgBxButtonCancelClick(Sender: TObject);
begin
     LMRsw1 := 2;
end;

//OK button (alone)
procedure TLocalMsgBxDlg1.CentralMsgBxButtonOK2Click(Sender: TObject);
begin
     LMRsw1 := 1;
end;

end.


