unit Unit2;
{$MODE Delphi}
////{$mode objfpc}{$H+}

interface

uses
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
    StdCtrls, ComCtrls, Menus, ExtCtrls, BGRAButton, Dialogs;

type

  { TForm2 }

  TForm2 = class(TForm)
    ClearAll1: TMenuItem;
    Panel1: TPanel;
    CloseButton2: TBGRAButton;
    SentMsgPanel: TPanel;
    LastWMLabel: TLabel;
    Memo1: TMemo;
    SentScrubButton: TBGRAButton;
    PopupMenu1: TPopupMenu;

    procedure CloseButton2Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ClearAll1Click(Sender: TObject);
    procedure Memo1DblClick(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SentScrubButtonClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
    ChangeSw: boolean;
    OnOne : boolean = True;        //this is set every time the form showmodals
    XRow : integer;
    XCol : integer;

implementation

uses Unit1, MsgBxDlgUnit1;

{$R *.frm}

//Disable ghosting
procedure DisableProcessWindowsGhosting;
var DisableProcessWindowsGhostingProc: procedure;
begin
//     DisableProcessWindowsGhostingProc := GetProcAddress(GetModuleHandle('user32.dll'), 'DisableProcessWindowsGhosting');
//     if Assigned(DisableProcessWindowsGhostingProc) then
//        DisableProcessWindowsGhostingProc;
end;

//FormCreate
procedure TForm2.FormCreate(Sender: TObject);
begin
////     DisableProcessWindowsGhosting;     //in FormCreate
end;

procedure TForm2.FormActivate(Sender: TObject);
begin
     if FileExists(ExtractFilePath(Application.ExeName) + 'System\SentMsgs.txt') then
        Memo1.Lines.LoadFromFile(ExtractFilePath(Application.ExeName) + 'System\SentMsgs.txt');

     OnOne := False;
end;

procedure TForm2.CloseButton2Click(Sender: TObject);
begin
     Close;
end;

procedure TForm2.ClearAll1Click(Sender: TObject);
begin
     MsgBxDlg1.CentralMessagesRtn(2, 'C*Clear all messages?');  // 1 = OK;  2 = OK/Cancel;  21 = OK/Cancel MsgBox

     if MsgBxDlg1.CheckModal <> mrOK then     //mrOK or mrCancel
        EXIT;                                 //EXIT

     Memo1.Clear;
     Memo1.Lines.SaveToFile(ExtractFilePath(Application.ExeName) + 'System\SentMsgs.txt');
end;

function GetMemoRowCol(M : TMemo): boolean;
begin
     XRow := SendMessage(M.Handle, EM_LINEFROMCHAR, M.SelStart, 0);
     Form2.Panel1.SetFocus;
     Result := True
end;

procedure GoToLine(LineNo : integer);
var CharNo : integer;
begin
     CharNo := Form1.Memo1.Perform(EM_LineIndex, LineNo, 0);
     Form1.Memo1.Perform(EM_SetSel, CharNo, CharNo);
     Form1.Memo1.Perform(EM_ScrollCaret, 0, 0);
     Form1.Memo1.SetFocus;
end;

//Click to recall pgp msg
procedure TForm2.Memo1DblClick(Sender: TObject);
var x : integer;
begin
     GetMemoRowCol(Memo1);

//     if pos('Message sent direct through', Memo1.Lines.Strings[XRow]) = 0 then begin
     if (pos('Subject:', Memo1.Lines.Strings[XRow]) > 0) or
        (pos('-----BEGIN PGP MESSAGE-----', Memo1.Lines.Strings[XRow]) > 0) then begin
        Form1.Memo1.Clear;
        Form1.Memo1.Lines.Add(Memo1.Lines.Strings[XRow]);

        for x := XRow + 1 to Memo1.Lines.Count - 1 do begin
            Form1.Memo1.Lines.Add(Memo1.Lines.Strings[x]);

            if pos('Message sent direct through', Memo1.Lines.Strings[x + 1]) > 0 then
               break;
            end;
        end
        else begin
        MsgBxDlg1.CentralMessagesRtn(1, 'C>Must click on a line containing' + #13 + '''Subject:'' or ''-----BEGIN PGP MESSAGE-----''');  // 1 = OK;  2 = OK/Cancel;  21 = OK/Cancel MsgBox
        EXIT;                                 //EXIT
        end;

     for x := Form1.Memo1.Lines.Count - 1 downto 0 do  //delete blank lines at end
         if Form1.Memo1.Lines.Strings[x] <> '' then begin
            GoToLine(0);
            break;
            end
            else
            Form1.Memo1.Lines.Delete(x);

     Close;
end;

//Memo1 change
procedure TForm2.Memo1Change(Sender: TObject);
begin
     if OnOne = False then
        ChangeSw := True;
end;

//FormClose
procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     if ChangeSw = True then begin
        MsgBxDlg1.ButtonParams('Yes', 'No');  //change button caption param
        MsgBxDlg1.CentralMessagesRtn(2, 'Save changes to ''Sent Messages'' window?');

        if MsgBxDlg1.CheckModal = mrOK then
           if FileExists(ExtractFilePath(Application.ExeName) + 'System\SentMsgs.txt') then
              Memo1.Lines.SaveToFile(ExtractFilePath(Application.ExeName) + 'System\SentMsgs.txt');
     end;

     ChangeSw := False;
end;

procedure TForm2.SentScrubButtonClick(Sender: TObject);
begin
     if not FileExists(ExtractFilePath(Application.ExeName) + 'System\SentMsgs.txt') then
        MsgBxDlg1.CentralMessagesRtn(1, '\System\SentMsgs.txt not found - scrub canceled!')
        else begin
        MsgBxDlg1.ButtonParams('Yes', 'No');  //change button caption param
        MsgBxDlg1.CentralMessagesRtn(2, 'C*Scrub the ''Sent Messages'' file?');

        if MsgBxDlg1.CheckModal = mrOK then begin
           CloseButton2.Enabled := False;
           SentScrubButton.Enabled := False;
           SentMsgPanel.Visible := True;
           SentMsgPanel.Caption := 'Scrubbing...';
           Application.ProcessMessages;
           sleep(1000);

           Form1.ScrubFile(ExtractFilePath(Application.ExeName) + 'System\SentMsgs.txt');
           SentMsgPanel.Caption := 'File scrubbed!';
           Application.ProcessMessages;
           sleep(2000);
           SentMsgPanel.Visible := False;
           CloseButton2.Enabled := True;
           SentScrubButton.Enabled := True;
           end;
        end;
end;

end.
