unit Unit3;

interface

uses
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
    Menus, StdCtrls, ComCtrls, ExtCtrls, BGRAButton;

type

  { TForm3 }

  TForm3 = class(TForm)
    ClearAll1: TMenuItem;
    LastWMLabel: TLabel;
    Memo1: TMemo;
    Panel1: TPanel;
    Panel2: TPanel;
    RecvScrubButton: TBGRAButton;
    PopupMenu1: TPopupMenu;
    RecvMsgPanel: TPanel;
    CloseButton3: TBGRAButton;

    procedure ClearAll1Click(Sender: TObject);
    procedure CloseButton3Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Memo1DblClick(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action2: TCloseAction);
    procedure RecvScrubButtonClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form3: TForm3;
    ChangeSw: boolean;
    OnOne : boolean = True;        //this is set every time the form showmodals
    XRow : integer;
    XCol : integer;

implementation

uses MsgBxDlgUnit1, Unit1;
{$R *.frm}

//Disable ghosting
procedure DisableProcessWindowsGhosting;
var DisableProcessWindowsGhostingProc: procedure;
begin
//     DisableProcessWindowsGhostingProc := GetProcAddress(GetModuleHandle('user32.dll'), 'DisableProcessWindowsGhosting');
//     if Assigned(DisableProcessWindowsGhostingProc) then
//        DisableProcessWindowsGhostingProc;
end;

//FormCreate
procedure TForm3.FormCreate(Sender: TObject);
begin
////     DisableProcessWindowsGhosting;     //in FormCreate
end;

//FormActivate
procedure TForm3.FormActivate(Sender: TObject);
begin
     if FileExists(ExtractFilePath(Application.ExeName) + 'System\ReceivedMsgs.txt') then
        Memo1.Lines.LoadFromFile(ExtractFilePath(Application.ExeName) + 'System\ReceivedMsgs.txt');

     OnOne := False;
end;

//Clear All menu item
procedure TForm3.ClearAll1Click(Sender: TObject);
begin
        MsgBxDlg1.CentralMessagesRtn(2, '                     Clear all messages?');  // 1 = OK;  2 = OK/Cancel;  21 = OK/Cancel MsgBox

        if MsgBxDlg1.CheckModal <> mrOK then     //mrOK or mrCancel
           EXIT;                                 //EXIT

     Memo1.Clear;
     Memo1.Lines.SaveToFile(ExtractFilePath(Application.ExeName) + 'System\ReceivedMsgs.txt');
end;

//Close button
procedure TForm3.CloseButton3Click(Sender: TObject);
begin
     Close;
end;

function GetMemoRowCol(M : TMemo) : LongInt;
begin
     XRow := SendMessage(M.Handle, EM_LINEFROMCHAR, M.SelStart, 0);
     Form3.Panel1.SetFocus;
end;

procedure GoToLine(LineNo : integer);
var CharNo : integer;
begin
     CharNo := Form1.Memo1.Perform(EM_LineIndex, LineNo, 0);
     Form1.Memo1.Perform(EM_SetSel, CharNo, CharNo);
     Form1.Memo1.Perform(EM_ScrollCaret, 0, 0);
     Form1.Memo1.SetFocus;
end;

//Click to recall pgp msg
procedure TForm3.Memo1DblClick(Sender: TObject);
var x : integer; StgLst : TStringList;
begin
     GetMemoRowCol(Memo1);

     if pos('-----BEGIN PGP MESSAGE-----', Memo1.Lines.Strings[XRow]) > 0 then begin
        Form1.Memo1.Clear;
        StgLst := TStringList.Create;

        for x := XRow to Memo1.Lines.Count - 1 do begin
            StgLst.Add(Memo1.Lines.Strings[x]);

            if pos('-----END PGP MESSAGE-----', Memo1.Lines.Strings[x]) > 0 then begin
               break;
               end;
        end;

        Form1.Memo1.Text := StgLst.Text;
        StgLst.Free;

        //correct split pgp input lines
        for x := Form1.Memo1.Lines.Count - 1 downto 0 do begin     //correct split pgp input lines
            if x > Form1.Memo1.Lines.Count - 4 then
               continue;

            if (Form1.Memo1.Lines.Strings[x] = '') or
               (Form1.Memo1.Lines.Strings[x] = '-----BEGIN PGP MESSAGE-----') or
               (Form1.Memo1.Lines.Strings[x] = '-----END PGP MESSAGE-----') then
               else
               if (length(Form1.Memo1.Lines.Strings[x]) < 64) then begin
                  Form1.Memo1.Lines.Strings[x] := Form1.Memo1.Lines.Strings[x - 1] +
                                                  Form1.Memo1.Lines.Strings[x];
                  Form1.Memo1.Lines.Delete(x - 1);
                  end;

            GoToLine(0);
        end;

        end
        else begin
        MsgBxDlg1.CentralMessagesRtn(1, 'C>Must click on a line containing' + #13 + '''-----BEGIN PGP MESSAGE-----''');  // 1 = OK;  2 = OK/Cancel;  21 = OK/Cancel MsgBox
        EXIT;                                 //EXIT
        end;

     for x := Form1.Memo1.Lines.Count - 1 downto 0 do  //delete blank lines at end
         if Form1.Memo1.Lines.Strings[x] <> '' then
            break
            else
            Form1.Memo1.Lines.Delete(x);

     Close;
end;

//Memo1 change
procedure TForm3.Memo1Change(Sender: TObject);
begin
     if OnOne = False then
        ChangeSw := True;
end;

//FormClose
procedure TForm3.FormClose(Sender: TObject; var Action2: TCloseAction);
begin
     if ChangeSw = True then begin
        MsgBxDlg1.ButtonParams('Yes', 'No');  //change button caption param
        MsgBxDlg1.CentralMessagesRtn(2, 'Save changes to ''Received Messages'' window?');

        if MsgBxDlg1.CheckModal = mrOK then
           if FileExists(ExtractFilePath(Application.ExeName) + 'System\ReceivedMsgs.txt') then
              Memo1.Lines.SaveToFile(ExtractFilePath(Application.ExeName) + 'System\ReceivedMsgs.txt');
     end;

     ChangeSw := False;
end;

procedure TForm3.RecvScrubButtonClick(Sender: TObject);
begin
     if not FileExists(ExtractFilePath(Application.ExeName) + 'System\ReceivedMsgs.txt') then
        MsgBxDlg1.CentralMessagesRtn(1, '\System\ReceivedMsgs.txt not found - scrub canceled!')
        else begin
        MsgBxDlg1.ButtonParams('Yes', 'No');  //change button caption param
        MsgBxDlg1.CentralMessagesRtn(2, 'C*Scrub the ''Received Messages'' file?');

        if MsgBxDlg1.CheckModal = mrOK then begin
           CloseButton3.Enabled := False;
           RecvScrubButton.Enabled := False;
           RecvMsgPanel.Visible := True;
           RecvMsgPanel.Caption := 'Scrubbing...';
           Application.ProcessMessages;
           sleep(1000);

           Form1.ScrubFile(ExtractFilePath(Application.ExeName) + 'System\ReceivedMsgs.txt');
           RecvMsgPanel.Caption := 'File scrubbed!';
           Application.ProcessMessages;
           sleep(2000);
           RecvMsgPanel.Visible := False;
           CloseButton3.Enabled := True;
           RecvScrubButton.Enabled := True;
           end;
        end;
end;

end.
