unit Unit1;

{$MODE Delphi}{$H+}
////{$mode objfpc}{$H+}

interface

uses
    Windows, Classes, SysUtils, IniPropStorage, Graphics, BGRAButton, Forms,
    Controls, StdCtrls, Process, Menus, ExtCtrls, LResources,
    LSControls, Clipbrd, Base64, Dialogs, DCPtwofish, DCPsha256, Zipper;

type

  { TForm1 }

  TForm1 = class(TForm)
    AddButton1: TBGRAButton;
    Append1: TBGRAButton;
    Clear1: TBGRAButton;
    CloseButton1: TBGRAButton;
    Copy1: TBGRAButton;
    DCP_sha256_1: TDCP_sha256;
    DCP_twofish1: TDCP_twofish;
    DecryptButton: TBGRAButton;
    DecryptFileMenuItem1: TMenuItem;
    DeleteThisKey1: TMenuItem;
    DisplayKeyring1: TMenuItem;
    DsplyKeys1: TBGRAButton;
    EncryptKeys1: TMenuItem;
    ExitMessage1: TPanel;
    File1: TBGRAButton;
    GenButton1: TBGRAButton;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    HelpButton1 : TBGRAButton;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    IniPropStorage2: TIniPropStorage;
    Label19: TLabel;
    ListBox1: TListBox;
    LockCkB1: TCheckBox;
    Margin1: TBGRAButton;
    Memo1: TMemo;
    Memo2 : TMemo;
    Memo3: TMemo;
    Memo4: TMemo;
    MemoUserPeer1: TMemo;
    MemoUserPeer2: TMemo;
    MemoUserPeer3: TMemo;
    MemoUserPeer4: TMemo;
    MemoUserPeer5: TMemo;
    MessagePanal1: TPanel;
    NotUsed: TCheckBox;
    OpenDialog1: TOpenDialog;
    OTP4: TBGRAButton;
    Panel1: TPanel;
    Panel20: TPanel;
    Panel21: TPanel;
    Panel4: TPanel;
    ParamsButton1: TBGRAButton;
    PopupMenu1: TPopupMenu;
    PopupMenu2: TPopupMenu;
    PopupMenu3: TPopupMenu;
    RetrievePanel1: TPanel;
    RtnData1: TBGRAButton;
    SaveDialog1: TSaveDialog;
    SendPanel1: TPanel;
    WindowToFile1: TMenuItem;

    procedure AddButton1Click(Sender: TObject);
    procedure ClearWorkArea1Click(Sender: TObject);
    procedure Clipboard1Click(Sender: TObject);
    procedure CloseButton1Click(Sender: TObject);
    procedure DecryptButtonClick(Sender: TObject);
    procedure EncryptKeys1Click(Sender: TObject);
    procedure File1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure GenButton1Click(Sender: TObject);
    procedure GroupBoxTitle1Change(Sender: TObject);
    procedure GroupBoxTitleCB1Change(Sender: TObject);
    procedure HelpButton1Click( Sender : TObject) ;
    procedure Label19Click(Sender: TObject);
    procedure ListKeys1Click(Sender: TObject);
    procedure LockCkB1Change(Sender: TObject);
    procedure Margin1Click(Sender: TObject);
    procedure MemoUserPeer1Click(Sender: TObject);
    procedure MemoUserPeer1KeyPress(Sender: TObject; var Key: char);
    procedure MemoUserPeer1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ParamsButton1Click(Sender: TObject);
    procedure RetrievePanel1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure RetrievePanel1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure RtnData1Click(Sender: TObject);
    procedure ScrubFile(FileNm : string; const ScrubCnt : integer = 3);
    procedure SendPanel1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure SendPanel1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure WindowToFile1Click(Sender: TObject);

  private
    procedure BreakUpRecord(Sender: TObject);
    procedure Decode(Sender: TObject);
    procedure Encode(Sender: TObject);
    procedure ProcessRtn(ProcessLine, Param: string);
    procedure WMQueryEndSession(var Msg: TWMQueryEndSession); message WM_QUERYENDSESSION;
    function FileSize( const FileName : String ) : LongInt;
  public
    function  RetrieveData(): boolean;
    function  SendData(): boolean;
    procedure AddPeer(ParmIn : string);
    procedure CDecryptBtnClick(Pp : string; DeInput : string; DeOutput : string);
    procedure CEncryptBtnClick(Pp : string; EnInput : string; EnOutput : string);
    procedure CreateKey();
    procedure Decrypt1Click(Sender: TObject);
    procedure Encrypt1Click(Sender: TObject);
    procedure ListFiles();
    procedure ListKeys();
    procedure Receive(ParmIn : string);
    procedure Scrub1Click(Sender: TObject);
    procedure Send(ParmIn : string);
    procedure UnZip();
    procedure UnZip1Click(Sender: TObject);
    procedure Zip();
  end;

var
   Form1: TForm1;  {data}
     DoneThis : boolean = False;
     Flname : string;
     ProcessFile : boolean = False;
     MemoFrom : TMemo;
     Row : integer;
     InvalidPassPhrase : integer = 0;
     SavePassword : string = '';


implementation

{$R *.frm}
uses MsgBxDlgUnit1, unit4, unit5, Unit7, Unit9;

{$INCLUDE EnDeCrypt.inc}

//Computer Shutdown Routine
procedure TForm1.WMQueryEndSession(var Msg: TWMQueryEndSession);
begin
     Close;
     Msg.result := 1;                //a must for complete shutdown
end;

//Disable ghosting
procedure DisableProcessWindowsGhosting;  {proc-func}
var DisableProcessWindowsGhostingProc: procedure;
begin
     DisableProcessWindowsGhostingProc := GetProcAddress(GetModuleHandle('user32.dll'), 'DisableProcessWindowsGhosting');

     if Assigned(DisableProcessWindowsGhostingProc) then
        DisableProcessWindowsGhostingProc;
end;

//Write String To
function WriteStringTo(const FileName: string; data : string): boolean;  {proc-func}
var outfile : text;
begin
     try
       assignfile(outfile, FileName);
       rewrite(outfile);

       write(outfile, data);

       closefile(outfile);
       Result := True;
     except
       Result := False;
     end;
end;

//FormCreate
procedure TForm1.FormCreate(Sender: TObject);  {proc-func}
var fMutex : THandle;
begin
     Memo1.Lines.LoadFromFile(Application.Location + 'Message.txt');

     if length(Memo1.Text) = 0 then begin
     //------------- begin mutex -------------------
        try
           fMutex := CreateMutex(nil, FALSE, @Application.Title[1]);
           if (GetLastError() = ERROR_ALREADY_EXISTS) or
              (WaitForSingleObject(fMutex,100) = WAIT_TIMEOUT) or
              (fMutex = 0) then begin
              Application.ShowMainForm := FALSE;
              ShowMessage('You can only have one instance of [' + UpperCase(Application.Title) + '] running at a time.');
              Application.Terminate;
              end;
        finally
             ReleaseMutex(fMutex);
             end;
     //---------------- end mutex ------------------
        end;

     Memo1.Clear;

     IniPropStorage2.Restore;
end;

//FormActivate
procedure TForm1.FormActivate(Sender: TObject);  {proc-func}
label loop1;
begin
     if DoneThis = False then begin
        DoneThis := True;
        Application.CreateForm(TMsgBxDlg1, MsgBxDlg1);

     if (EncryptKeys1.Checked = True) and      // test to see if pgm was terminated before keys were encrypted
        (not FileExists(Application.Location + '.UserKeys\archive.asc')) then begin
        MsgBxDlg1.CentralMessagesRtn(1, 'There is an indication that the program did not' + #13 +
                                        'terminate correctly from the previous session.' + #13 +
                                        '''Encrypt Keys'' will be unchecked and must be' + #13 +
                                        're-checked again upon restart.');
        EncryptKeys1.Checked := False;
        IniPropStorage2.Save;

        Halt;
        EXIT;                                 //EXIT
        end;

loop1:
        if EncryptKeys1.Checked = True then begin
           MsgBxDlg1.ButtonParams('OK', 'Cancel');
           SavePassword := MsgBxDlg1.CentralMessagesRtn(21, 'C*Enter password or Cancel.');

           if MsgBxDlg1.CheckModal <> mrOK then begin
              Halt;
              EXIT;                                 //EXIT
              end;

           Decrypt1Click(nil);

           if InvalidPassPhrase = 1 then begin
              MsgBxDlg1.ButtonParams('Retry', 'Cancel');
              MsgBxDlg1.CentralMessagesRtn(2, 'C*Invalid password!');

              if MsgBxDlg1.CheckModal <> mrOK then begin
                 Halt;
                 EXIT;                                 //EXIT
                 end;

              goto loop1;
              end;

           UnZip();
           ScrubFile(Application.Location + '.UserKeys\archive.zip', 3);
           DeleteFile(Application.Location + '.UserKeys\archive.zip');
        end;

     MemoUserPeer1.Lines.LoadFromFile(Application.Location + '.UserKeys\UserPeer1.txt');
     MemoUserPeer2.Lines.LoadFromFile(Application.Location + '.UserKeys\UserPeer2.txt');
     MemoUserPeer3.Lines.LoadFromFile(Application.Location + '.UserKeys\UserPeer3.txt');
     MemoUserPeer4.Lines.LoadFromFile(Application.Location + '.UserKeys\UserPeer4.txt');
     MemoUserPeer5.Lines.LoadFromFile(Application.Location + '.UserKeys\UserPeer5.txt');
     end; //DoneThis
end;

//Scrub files
procedure TForm1.ScrubFile(FileNm : string; const ScrubCnt : integer);  {proc-func}
var f : textfile; x, y, ttlBytes, AHandle : integer;
begin
     try

     //get bytes in file
     AHandle := FileOpen(FileNm, fmShareDenyNone);
     ttlBytes := GetFileSize(AHandle, nil);
     FileClose(AHandle);

     //overwrite file data
     for x := 1 to ScrubCnt do begin    //do it ScrubCnt times
         AssignFile(f, FileNm);
         Rewrite(f);

         for y := 1 to ttlBytes do     //do it for each byte of file
             write(f, #255);

         CloseFile(f);
     end;

     except
     end;

     AssignFile(f, FileNm);
     Rewrite(f);
     CloseFile(f);
end;


//-----------------------------------//
//   Encode / Decode Section BEGIN   //
//-----------------------------------//
//Read in binary string
function FileToString(const FileName: string): string;
var F: TFileStream;
begin
     F := TFileStream.Create(FileName, fmOpenRead or fmShareDenyWrite);
     SetLength(Result, F.Size);
     F.ReadBuffer(PChar(Result)^, F.Size);
     F.Free;
end;

//Write out encoded file
procedure StringToFile(const FileName: string; s : string);
var fs : TFileStream;
begin
     fs:= TFileStream.Create(FileName, fmCreate);
     fs.WriteBuffer(Pointer(s)^, Length(s));
     fs.Free;
end;

//Encode file
procedure TForm1.Encode(Sender: TObject);
var s : string; t : AnsiString;
begin
     s := FileToString(Application.Location + 'SealOut.txt');
     t := EncodeStringBase64(s);
     StringToFile(Application.Location + 'EncodeMessageOut0.txt', t);  // unbroken string to EncodeMessageOut0

     Memo2.Text := t;
end;

//Decode file
procedure TForm1.Decode(Sender: TObject);
var u : string; t : AnsiString;
begin
     t := FileToString(Application.Location + 'MessageIn.txt');
     u := DecodeStringBase64(t);
     StringToFile(Application.Location + 'sealin.txt', u);
end;
//=================================//
//   Encode / Decode Section END   //
//=================================//


//=======================================//
//   NaCl Box Encryption Section BEGIN   //
//=======================================//
//Process
procedure TForm1.ProcessRtn(ProcessLine, Param: string);
var AProcess: TProcess;
begin
     AProcess := TProcess.Create(nil);
     try
       AProcess.ShowWindow := swoHIDE;
       AProcess.Options := [poWaitOnExit];

       AProcess.Parameters.Add(Param);

       AProcess.Executable := ProcessLine;
       AProcess.Execute();
     finally
       AProcess.Free();
     end;
end;
                                
//Create KeyID
procedure TForm1.CreateKey();
begin
     ProcessRtn(Application.Location + 'System\xcreate.bat', ''); //  box-master.exe new-identity -name john (defaults to 'self' if -name left out)
end;

//Create list
procedure TForm1.ListKeys();
begin
     ProcessRtn(Application.Location + 'System\xlist.bat', ''); //  box-master.exe list >list1.txt
end;

//Add Peer
procedure TForm1.AddPeer(ParmIn : string);
begin
     ProcessRtn(Application.Location + 'System\xaddpeer.bat', ''); //  box-master.exe add-peer -name ann -key 14a303908133a21c2a3c744e05426e2c36d9d0eb97266b9ec674e959162f3e17
end;

//Seal Send encrypt
procedure TForm1.Send(ParmIn : string);
begin
     ProcessRtn(Application.Location + 'System\xseal.bat', ''); //  box-master.exe seal -from john -to ann <Message.txt >seal.txt (defaults to 'self' if -from left out)
end;

//Receive decrypt
procedure TForm1.Receive(ParmIn : string);
begin
     ProcessRtn(Application.Location + 'System\xreceive.bat', ''); //  box-master.exe open -from ann -to john <seal.txt >message.txt (defaults to 'self' if -to left out)
end;
//=====================================//
//   NaCl Box Encryption Section END   //
//=====================================//


//GroupBox Title On Change
procedure TForm1.GroupBoxTitle1Change(Sender: TObject);
  //Get numerics
  function get_nums(strng : string) : string;
  var  lc, mc : integer;
  begin
       result := '';
      mc := length(strng);
      for lc := 1 to mc do begin
        if (strng[lc] in [{'.','+','-',}'0'..'9']) then begin
          result := result + strng[lc];
        end;
      end;
  end;

var x : integer;
begin
     x := strtoint(get_nums(TGroupBox(Sender).Name));
     TGroupBox(FindComponent('GroupBox' + inttostr(x))).Caption := TEdit(Sender).Text;
end;

//All GroupBox Title CB change
procedure TForm1.GroupBoxTitleCB1Change(Sender: TObject);
  //Get numerics
  function get_nums(strng : string) : string;
  var  lc, mc : integer;
  begin
       result := '';
      mc := length(strng);
      for lc := 1 to mc do begin
        if (strng[lc] in [{'.','+','-',}'0'..'9']) then begin
          result := result + strng[lc];
        end;
      end;
  end;

var x : integer;
begin
     x := strtoint(get_nums(TCheckBox(Sender).Name));

     if TCheckBox(Sender).Checked = True then
        TGroupBox(FindComponent('GroupBox' + inttostr(x))).Visible := True
        else
        TGroupBox(FindComponent('GroupBox' + inttostr(x))).Visible := False;
end;

//CloseQuery
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);  {proc-func}
label loop1;
begin
     IniPropStorage2.Save;
     MemoUserPeer1.Lines.SaveToFile(Application.Location + '.UserKeys\UserPeer1.txt');
     MemoUserPeer2.Lines.SaveToFile(Application.Location + '.UserKeys\UserPeer2.txt');
     MemoUserPeer3.Lines.SaveToFile(Application.Location + '.UserKeys\UserPeer3.txt');
     MemoUserPeer4.Lines.SaveToFile(Application.Location + '.UserKeys\UserPeer4.txt');
     MemoUserPeer5.Lines.SaveToFile(Application.Location + '.UserKeys\UserPeer5.txt');

loop1:
     if EncryptKeys1.Checked = True then begin
        if trim(SavePassword) = '' then begin
        MsgBxDlg1.Show1.Checked := True;     // maskedit messes uo with doing this
        MsgBxDlg1.Show1.Checked := False;
           MsgBxDlg1.ButtonParams('OK', 'Cancel');
           SavePassword := MsgBxDlg1.CentralMessagesRtn(21, 'C*Enter password in box or Cancel.');

           if MsgBxDlg1.CheckModal = mrOK then begin
              if trim(SavePassword) <> '' then begin
                 Zip();
                 Encrypt1Click(nil);
                 Scrub1Click(nil);
                 end
                 else
                 goto loop1;
                 end
                 else begin
                 SavePassword := '';
                 EncryptKeys1.Checked := False;
                 MsgBxDlg1.CentralMessagesRtn(1, 'C*Keys not encrypted! ''Encrypt Keys'' has been unchecked!');
                 end;
        end
        else begin
        Zip();
        Encrypt1Click(nil);
        Scrub1Click(nil);
        end;
     end;

     ExitMessage1.Visible := True;
     Application.ProcessMessages;

     ScrubFile(Application.Location + 'EncodeMessageOut0.txt', 3);
     ScrubFile(Application.Location + 'EncodeMessageOut64.txt', 3);
     ScrubFile(Application.Location + 'ListKeys.txt', 3);
     ScrubFile(Application.Location + 'MessageIn.txt', 3);
     ScrubFile(Application.Location + 'MessageOut.txt', 3);
     ScrubFile(Application.Location + 'SealIn.txt', 3);
     ScrubFile(Application.Location + 'SealOut.txt', 3);
     ScrubFile(Application.Location + 'System\xaddpeer.bat', 3);
     ScrubFile(Application.Location + 'System\xcreate.bat', 3);
     ScrubFile(Application.Location + 'System\xreceive.bat', 3);
     ScrubFile(Application.Location + 'System\xseal.bat', 3);
end;

//Close button
procedure TForm1.CloseButton1Click(Sender: TObject);  {proc-func}
begin
     Close;
end;

//Clear Memo1
procedure TForm1.ClearWorkArea1Click(Sender: TObject);  {proc-func}
begin
     if Memo1.Text = '' then
        EXIT;                                 //EXIT

     Memo3.Text := Memo1.Text;
     Memo1.Clear;
     Memo1.SetFocus;
end;

//Lock checkbox
procedure TForm1.LockCkB1Change(Sender: TObject);
begin
     if LockCkB1.Checked = True then begin
        MemoUserPeer1.Color := clDefault;
        MemoUserPeer2.Color := clDefault;
        MemoUserPeer3.Color := clDefault;
        MemoUserPeer4.Color := clDefault;
        MemoUserPeer5.Color := clDefault;
        MemoUserPeer1.OnClick := MemoUserPeer1Click;
        MemoUserPeer2.OnClick := MemoUserPeer1Click;
        MemoUserPeer3.OnClick := MemoUserPeer1Click;
        MemoUserPeer4.OnClick := MemoUserPeer1Click;
        MemoUserPeer5.OnClick := MemoUserPeer1Click;
        MemoUserPeer1.ReadOnly := True;
        MemoUserPeer2.ReadOnly := True;
        MemoUserPeer3.ReadOnly := True;
        MemoUserPeer4.ReadOnly := True;
        MemoUserPeer5.ReadOnly := True;
        Memo1.SetFocus;
        end
        else begin
        MemoUserPeer1.Color := cl3DLight;
        MemoUserPeer2.Color := cl3DLight;
        MemoUserPeer3.Color := cl3DLight;
        MemoUserPeer4.Color := cl3DLight;
        MemoUserPeer5.Color := cl3DLight;
        MemoUserPeer1.OnClick := nil;
        MemoUserPeer2.OnClick := nil;
        MemoUserPeer3.OnClick := nil;
        MemoUserPeer4.OnClick := nil;
        MemoUserPeer5.OnClick := nil;
        MemoUserPeer1.ReadOnly := False;
        MemoUserPeer2.ReadOnly := False;
        MemoUserPeer3.ReadOnly := False;
        MemoUserPeer4.ReadOnly := False;
        MemoUserPeer5.ReadOnly := False;
        end;
end;

//Add peer button
procedure TForm1.AddButton1Click(Sender: TObject);
begin
     Form4.ShowModal;
end;

//Break up record to 64
procedure TForm1.BreakUpRecord(Sender: TObject);
var FromF, ToF: file;
    x, NumRead, NumWritten: Integer;
    Buf : array[1..64] of Char;
    Buf2 : array[1..64] of Char;
begin
     AssignFile(FromF, Application.Location + 'EncodeMessageOut0.txt');
     Reset(FromF, 1);

     AssignFile(ToF, Application.Location + 'EncodeMessageOut64.txt');

     Rewrite(ToF, 1);
     repeat
        BlockRead(FromF, Buf, SizeOf(Buf), NumRead);
        for x := Low(Buf) to High(Buf) do
            Buf2[x] := Buf[x];

        Buf2[High(Buf) + 1] := #13;
        Buf2[High(Buf) + 2] := #10;

        if NumRead < High(Buf) then
           BlockWrite(ToF, Buf2, NumRead, NumWritten)
           else
           BlockWrite(ToF, Buf2, NumRead + 2, NumWritten)

     until (NumRead = 0) or ((NumWritten - 2) <> NumRead);

     CloseFile(FromF);
     CloseFile(ToF);
end;

//Generate key
procedure TForm1.GenButton1Click(Sender: TObject);
begin
     Form3.ShowModal;
end;

procedure TForm1.Label19Click(Sender: TObject);
begin
     if LockCkB1.Checked = True then
        LockCkB1.Checked := False
        else
        LockCkB1.Checked := True;
end;

//Copy to cb menu item
procedure TForm1.Clipboard1Click(Sender: TObject);  {proc-func}
begin
    Memo1.SelectAll;
    Memo1.CopyToClipboard;
    Memo1.SelStart := 0;
end;

//List Keys
procedure TForm1.ListKeys1Click(Sender: TObject);
begin
     Form2.Memo1.Clear;
     ListKeys();

     Form2.Memo1.Lines.LoadFromFile('ListKeys.txt');
     Form2.ShowModal;
end;

//Margin1 Click
procedure TForm1.Margin1Click(Sender: TObject);
begin
     if Margin1.Down = False then begin
        Margin1.Down := True;
        Memo1.WordWrap := True;
        end
        else begin
        Margin1.Down := False;
        Memo1.WordWrap := False;
        end;

    Memo1.SelStart := 65000;
end;

//Find file size
function TForm1.FileSize( const FileName : String ) : LongInt;
var hFile          : THandle; // handle of file to get size of
    lpFileSizeHigh : DWORD;   // address of high-order WORD for file size
begin
     Result := -1;
     hFile := FileOpen( FileName, fmShareDenyNone );
     try
        if hFile <> 0 then
           Result := Windows.GetFileSize( hFile, @lpFileSizeHigh );
     finally
        FileClose( hFile );
     end; // try
end;

//File button
procedure TForm1.File1Click(Sender: TObject);
begin
     if File1.Down = False then begin
        File1.Down := True;
        ProcessFile := True;
        File1.BodyClicked.Font.Color := clRed;
        File1.BodyHover.Font.Color := clRed;
        File1.BodyNormal.Font.Color := clRed;
        File1.BodyClicked.Font.Style := [fsBold];
        File1.BodyHover.Font.Style := [fsBold];
        File1.BodyNormal.Font.Style := [fsBold];
        end
        else begin
        File1.Down := False;
        ProcessFile := False;
        File1.BodyClicked.Font.Color := clNavy;
        File1.BodyHover.Font.Color := clNavy;
        File1.BodyNormal.Font.Color := clNavy;
        File1.BodyClicked.Font.Style := [];
        File1.BodyHover.Font.Style := [];
        File1.BodyNormal.Font.Style := [];
        end;

    Memo1.SelStart := 65000;
end;

//All Memos click
procedure TForm1.MemoUserPeer1Click(Sender: TObject);
var UserName, PeerName : string; x : integer; KeyNameArray : array[0..100] of string; UserNameFound, PeerNameFound : boolean;
begin
     for x := Memo1.Lines.Count - 1 downto 0 do
         if pos('--- Decrypt keys:', Memo1.Lines.Strings[x]) > 0 then
            Memo1.Lines.Delete(x);


     if File1.Down = True then begin
        MsgBxDlg1.CentralMessagesRtn(2, 'C*Encrypt a file?');
        if MsgBxDlg1.CheckModal <> mrOK then begin

           if File1.Down = True then
              File1Click(nil);

           EXIT;
           end;

        OpenDialog1.InitialDir := Application.Location;
        OpenDialog1.DefaultExt := '*.*';

        if OpenDialog1.Execute then begin
           Flname := OpenDialog1.FileName;
           CopyFile(PChar(Flname), PChar('MessageOut.txt'), False);
           ProcessFile := True;
           end
           else begin
           MsgBxDlg1.CentralMessagesRtn(1, 'C*Open canceled!');

           if File1.Down = True then
              File1Click(nil);

           EXIT;                                       //   Cancel button goes to here
           end;
     end;

     if (ProcessFile = False) and (trim(Memo1.Text) = '') then begin
        MsgBxDlg1.CentralMessagesRtn(1, 'C*No message in window to encrypt!');
        Memo1.SetFocus;
        EXIT;                                 //EXIT
        end;

     UserName := trim(copy(MemoFrom.Lines.Strings[Row], 1, pos('/', MemoFrom.Lines.Strings[Row]) - 1));
     PeerName := trim(copy(MemoFrom.Lines.Strings[Row], pos('/', MemoFrom.Lines.Strings[Row]) + 1, 100));

     //chk to see if key names selected are in keyring
     UserNameFound := False;
     PeerNameFound := False;
     ZeroMemory(@KeyNameArray, sizeof(KeyNameArray));      // clear arrays

     ListKeys();   // get keys
     Memo2.Lines.LoadFromFile(Application.Location + 'ListKeys.txt');  //load key list into Memo2

     for x := 0 to Memo2.Lines.Count - 1 do                // get all identity names
         KeyNameArray[x] := copy(Memo2.Lines.Strings[x], 1, pos(' ', Memo2.Lines.Strings[x]) - 1);  // get key name

     for x := Low(KeyNameArray) to High(KeyNameArray) do   // load up KeyNames
         if KeyNameArray[x] = UserName then begin
            UserNameFound := True;
            break;
            end;

     for x := Low(KeyNameArray) to High(KeyNameArray) do   // load up KeyNames
         if KeyNameArray[x] = PeerName then begin
            PeerNameFound := True;
            break;
            end;

     if (UserNameFound = False) or (PeerNameFound = False) then begin
        MsgBxDlg1.CentralMessagesRtn(1, 'C*No key found for one or both selected key names!');
        EXIT;                                 //EXIT
        end;

     if (trim(UserName) = '') or (trim(PeerName) = '') then begin
        MsgBxDlg1.CentralMessagesRtn(1, 'C*UserName or PeerName missing!');
        Memo1.SetFocus;
        EXIT;                                 //EXIT
        end;
     //END chk to see if key names selected are in keyring

     if ProcessFile = False then
        Memo1.Lines.SaveToFile('MessageOut.txt');   // it true, then processing a file. See EncryptFileMI1Click.

     WriteStringTo(Application.Location + 'System\xseal.bat', 'box-master.exe seal -from ' +
                   UserName + ' -to ' + PeerName + ' <MessageOut.txt >sealout.txt');

     if ProcessFile = False then begin
        MsgBxDlg1.ButtonParams('Yes', 'Cancel');
        MsgBxDlg1.CentralMessagesRtn(2, 'C*Do you want to encrypt the message from ''' + UserName + ''' to ''' + PeerName + '''?');
        end
        else begin
        MsgBxDlg1.ButtonParams('Yes', 'Cancel');
        MsgBxDlg1.CentralMessagesRtn(2, 'C*Do you want to encrypt the selected file from ''' + UserName + ''' to ''' + PeerName + '''?');
        end;

     if MsgBxDlg1.CheckModal = mrOK then begin
        Memo3.Text := Memo1.Text;  //temp save unencrypted msg
        MessagePanal1.Caption := 'Encrypting...';
        MessagePanal1.Visible := True;
        Application.ProcessMessages;

        Send('');                                              // <============================== NaCl Box encrypt message

        sleep(1500);
        MessagePanal1.Visible := False;
        Application.ProcessMessages;

        if ProcessFile = False then
           Memo1.Text := Memo2.Text;
        end
        else begin
        MsgBxDlg1.CentralMessagesRtn(1, 'C*Message canceled');

        if File1.Down = True then
           File1Click(nil);

        Memo1.SetFocus;
        EXIT;                                 //EXIT
        end;

     Encode(nil);        // Base64 encode binary encrypted output
     BreakUpRecord(nil); // break record to 64 len

     if ProcessFile = False then begin
        Memo1.Lines.LoadFromFile(Application.Location + 'EncodeMessageOut64.txt');

        if Form5.EncaseCB1.Checked = True then begin
           Memo1.Lines.Insert(0, '=== BEGIN NaCL ENCRYPTION ===');
           Memo1.Lines.Append('=== END NaCL ENCRYPTION ===');
           end;

        end
        else begin
        MsgBxDlg1.ButtonParams('File', 'Window');
        MsgBxDlg1.CentralMessagesRtn(2, 'C*A file was encrypted. Do you want to output to a file or to the main window?');

        if MsgBxDlg1.CheckModal <> mrOK then begin
           MessagePanal1.Caption := 'Loading main window...';
           MessagePanal1.Visible := True;
           Application.ProcessMessages;
           Memo1.Lines.LoadFromFile(Application.Location + 'EncodeMessageOut64.txt');
           sleep(1500);
           MessagePanal1.Visible := False;
           Application.ProcessMessages;
           end
           else begin
           SaveDialog1.InitialDir := Application.Location;
           SaveDialog1.DefaultExt := '*.*';

           if SaveDialog1.Execute then begin
              Flname := SaveDialog1.FileName;
              MessagePanal1.Caption := 'Output to file...';
              MessagePanal1.Visible := True;
              Application.ProcessMessages;
              CopyFile(PChar(Application.Location + 'EncodeMessageOut64.txt'), PChar(Flname), False);
              sleep(1500);
              MessagePanal1.Visible := False;
              Application.ProcessMessages;
              end
              else begin
              MessagePanal1.Visible := False;
              MsgBxDlg1.CentralMessagesRtn(1, 'C*Save canceled!');

              if File1.Down = True then
                 File1Click(nil);

              EXIT;                                       //   Cancel button goes to here
              end;
           end;
        end;

     if File1.Down = True then
        File1Click(nil);

     ProcessFile := False;
     Memo1.SetFocus;
//box-master.exe seal -from john -to ann <message.txt >seal.txt
end;

//Decrypt message
procedure TForm1.DecryptButtonClick(Sender: TObject);
var x, y, z : integer; KeyIdentityArray, KeyPeerArray : array[0..100] of string; DecryptProcessedOK : boolean;
    SaveDecryptKeys : string;
label Bypass1;
begin
     SaveDecryptKeys := '';

     if File1.Down = True then begin
        MsgBxDlg1.CentralMessagesRtn(2, 'C*Decrypt a file?');
        if MsgBxDlg1.CheckModal <> mrOK then begin

           if File1.Down = True then
              File1Click(nil);

           EXIT;
           end;

        OpenDialog1.InitialDir := Application.Location;
        OpenDialog1.DefaultExt := '*.*';

        if OpenDialog1.Execute then begin
           Flname := OpenDialog1.FileName;
           CopyFile(PChar(Flname), PChar('MessageIn.txt'), False);
           ProcessFile := True;
           end
           else begin
           MsgBxDlg1.CentralMessagesRtn(1, 'C*Open canceled!');

           if File1.Down = True then
              File1Click(nil);

           EXIT;                                       //   Cancel button goes to here
           end;
     end;

     if (ProcessFile = False) and (trim(Memo1.Text) = '') then begin
        MsgBxDlg1.CentralMessagesRtn(1, 'C*No message in window to decrypt!');
        EXIT;                                 //EXIT
        end;

     if ProcessFile = False then begin
        Memo4.Text := Memo1.Text;

        for x := Memo4.Lines.Count - 1 downto 0 do           // strip out header/trailer
            if (pos('=== BEGIN NaCL ENCRYPTION ===', Memo4.Lines.Strings[x]) > 0) or
               (pos('=== END NaCL ENCRYPTION ===', Memo4.Lines.Strings[x]) > 0) then
               Memo4.Lines.Delete(x);

        Memo4.Lines.SaveToFile(Application.Location + 'MessageIn.txt');
     end;

     Decode(nil);  // de-Base64 into sealin.txt

     //go thru and gather keys to discover correct decrypt key
     ZeroMemory(@KeyIdentityArray, sizeof(KeyIdentityArray));      // clear arrays
     ZeroMemory(@KeyPeerArray, sizeof(KeyPeerArray));

     ListKeys();   // get keys
     Memo2.Lines.LoadFromFile(Application.Location + 'ListKeys.txt');  //load key list into Memo2

     y := 0;

     for x := 0 to Memo2.Lines.Count - 1 do             // get all identity names
         if pos('identity', Memo2.Lines.Strings[x]) > 0 then begin
            KeyIdentityArray[y] := copy(Memo2.Lines.Strings[x], 1, pos(' ', Memo2.Lines.Strings[x]) - 1);
            inc(y);
            end;

     y := 0;

     for x := 0 to Memo2.Lines.Count - 1 do              // get all peer names
         if pos('peer', Memo2.Lines.Strings[x]) > 0 then begin
            KeyPeerArray[y] := copy(Memo2.Lines.Strings[x], 1, pos(' ', Memo2.Lines.Strings[x]) - 1);
            inc(y);
            end;
     //END go thru and gather keys to discover correct decrypt key


     DecryptProcessedOK := False;

     x := 0;
     for x := Low(KeyIdentityArray) to High(KeyIdentityArray) do begin   // load up KeyNames
         if DecryptProcessedOK = True then                               // message decrypted ok
            break;

         if (KeyIdentityArray[x] = '') then begin                        // stop processing when no more array entries
            MessagePanal1.Visible := False;
            MsgBxDlg1.CentralMessagesRtn(1, 'C*Unable to decrypt message!  A valid decrypt key was not found.');
            EXIT;                                 //EXIT
            end;

         y := 0;
         for y := Low(KeyPeerArray) to High(KeyPeerArray) do begin    // load up KeyNames
             if KeyPeerArray[y] = '' then                          // stop processing when no more array entries
                break;                                 //EXIT

             WriteStringTo(Application.Location + 'System\xreceive.bat', 'box-master.exe open -from ' +
                           KeyPeerArray[y] + ' -to ' + KeyIdentityArray[x] + ' <SealIn.txt >Message.txt');

             MessagePanal1.Caption := 'Decrypting...';
             MessagePanal1.Visible := True;
             Application.ProcessMessages;

             Receive('');                       // <============================== NaCl Box decrypt message

             sleep(1500);
////             MessagePanal1.Visible := False;
////             Application.ProcessMessages;

             z := 0;
             z := FileSize(Application.Location + 'Message.txt'); // chk file size to see if decryption worked

             if z > 0 then begin
////                MsgBxDlg1.CentralMessagesRtn(1, 'C*Decrypt keys: ' + KeyIdentityArray[x] + '/' + KeyPeerArray[y]);
                SaveDecryptKeys := '--- Decrypt keys: ' + KeyIdentityArray[x] + '/' + KeyPeerArray[y] + ' ---';
                goto Bypass1;
                end;
         end;
     end;

Bypass1:

     MessagePanal1.Visible := False;
     Application.ProcessMessages;

     if ProcessFile = False then
        Memo1.Lines.LoadFromFile(Application.Location + 'Message.txt')
        else begin
        MsgBxDlg1.ButtonParams('File', 'Window');
        MsgBxDlg1.CentralMessagesRtn(2, 'C*A file was decrypted. Do you want to output to a file or to the main window?');

        if MsgBxDlg1.CheckModal <> mrOK then
           Memo1.Lines.LoadFromFile(Application.Location + 'Message.txt')
           else begin
           SaveDialog1.InitialDir := Application.Location;
           SaveDialog1.DefaultExt := '*.*';

           if SaveDialog1.Execute then begin
              Flname := SaveDialog1.FileName;
              CopyFile(PChar(Application.Location + 'Message.txt'), PChar(Flname), False);
              end
              else begin
              MsgBxDlg1.CentralMessagesRtn(1, 'C*Save canceled!');

              if File1.Down = True then
                 File1Click(nil);

              EXIT;                                       //   Cancel button goes to here
              end;
           end;
        end;

     Memo1.Lines.Insert(0, SaveDecryptKeys);  // insert decrypt keys used

     if File1.Down = True then
        File1Click(nil);

     ScrubFile(Application.Location + 'Message.txt', 3);
     ProcessFile := False;
end;

//Encrypt Keys menu item
procedure TForm1.EncryptKeys1Click(Sender: TObject);
begin
     SavePassword := '';

     if EncryptKeys1.Checked = True then begin
        EncryptKeys1.Checked := False;
        end
        else begin
        EncryptKeys1.Checked := True;
        end;
end;

//MemoUserPeer1 KeyPress
procedure TForm1.MemoUserPeer1KeyPress(Sender: TObject; var Key: char);
var Row : integer;
begin
     Row := SendMessage(TMemo(Sender).Handle, EM_LINEFROMCHAR,	TMemo(Sender).SelStart, 0);
     if (Row = 4) and (Key = Chr(VK_RETURN)) then begin   //use this one
        Key := #0;
        end;
end;

//MemoUserPeer1 MouseDown
procedure TForm1.MemoUserPeer1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     MemoFrom := TMemo(Sender);
     Row := SendMessage(MemoFrom.Handle, EM_LINEFROMCHAR, MemoFrom.SelStart, 0);
end;

//Help
procedure TForm1.HelpButton1Click( Sender : TObject);
begin
     ProcessRtn('Quiet.exe', Application.Location + 'Help\Help.html');
end;

//Params button
procedure TForm1.ParamsButton1Click(Sender: TObject);
begin
     Form5.ShowModal;
end;

//Main Window To File
procedure TForm1.WindowToFile1Click(Sender: TObject);
var x : integer; FlnameWinToFl : string;
begin
     SaveDialog1.InitialDir := Application.Location;
     SaveDialog1.DefaultExt := '*.*';

     if SaveDialog1.Execute then begin
        MessagePanal1.Caption := 'Writing file...';
        MessagePanal1.Visible := True;
        Application.ProcessMessages;

        FlnameWinToFl := SaveDialog1.FileName;

        Memo4.Text := Memo1.Text;

        for x := Memo4.Lines.Count - 1 downto 0 do           // strip out header/trailer
            if (pos('=== BEGIN NaCL ENCRYPTION ===', Memo4.Lines.Strings[x]) > 0) or
               (pos('=== END NaCL ENCRYPTION ===', Memo4.Lines.Strings[x]) > 0) then
               Memo4.Lines.Delete(x);

        Memo4.Lines.SaveToFile(FlnameWinToFl);
        sleep(1500);
        MessagePanal1.Visible := False;
        Application.ProcessMessages;
        end
        else
        MsgBxDlg1.CentralMessagesRtn(1, 'C*Save canceled!');
end;

//=======================================================//
//   Send Retrieve Data to/from a window section BEGIN   //
//=======================================================//
//Send data
function TForm1.SendData(): boolean;
begin
     Result := True;

     if Clipboard.HasFormat(CF_TEXT) then
        else
        EXIT;                                 //EXIT;

     Memo1.SelectAll;
     Memo1.CopyToClipboard;
     Application.ProcessMessages;
     Memo1.SelStart := 0;


     Keybd_event(VK_CONTROL, 0, 0, 0);
     Keybd_event(ord('V'), 0, 0, 0);
     Keybd_event(ord('V'), 0, KEYEVENTF_KEYUP, 0);
     Keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0);
     Application.ProcessMessages;
     sleep(1000);
end;

//SendPanel1 MouseDown
procedure TForm1.SendPanel1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var hCur: HCURSOR;
begin
     case Button of                   //popup menu at cursor
          mbLeft : begin                                   //   EXIT
                   hCur := LoadCursorFromFile(PChar(ExtractFilePath(Application.ExeName) + 'System\Sight.cur'));
                   Screen.Cursors[1] := hCur;
                   Screen.Cursor := 1;

                   SendPanel1.OnMouseDown := nil;  //delimrter
                   end;
     end;
end;

//SendPanel1 MouseUp
procedure TForm1.SendPanel1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     case Button of                   //popup menu at cursor
          mbLeft : begin                                   //   EXIT
                   Mouse_Event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);  //no positioning needed here
                   Mouse_Event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
                   Application.Minimize;
                   Application.ProcessMessages;

                   SendData();

                   ShowWindow(Form1.Handle, SW_SHOW);   //only this will show form after Hide
                   Form1.BringToFront;

                   Screen.Cursor := crDefault;
                   SendPanel1.OnMouseDown := SendPanel1MouseDown;
                   end;
     end;
end;

//Retrieve data
function TForm1.RetrieveData(): boolean;
var TestCBGood : boolean;
begin
     Result := True;

     if Clipboard.HasFormat(CF_TEXT) then
        else
        EXIT;                                 //EXIT;

     Memo1.Clear;

     Keybd_event(VK_CONTROL, 0, 0, 0);
     Keybd_event(ord('A'), 0, 0, 0);
     Keybd_event(ord('A'), 0, KEYEVENTF_KEYUP, 0);
     Keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0);
     Application.ProcessMessages;
     sleep(500);                         //must delay here or data not captured
     Keybd_event(VK_CONTROL, 0, 0, 0);
     Keybd_event(ord('C'), 0, 0, 0);
     Keybd_event(ord('C'), 0, KEYEVENTF_KEYUP, 0);
     Keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0);
     Application.ProcessMessages;
     sleep(500);
     Keybd_event(VK_CONTROL, 0, 0, 0);
     Keybd_event(VK_END, 0, 0, 0);
     Keybd_event(VK_END, 0, KEYEVENTF_KEYUP, 0);
     Keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0);
     Application.ProcessMessages;
     sleep(1000);

     repeat
       TestCBGood := True;
       try
         Memo1.PasteFromClipboard;
       except
         TestCBGood := False;
       end;
     until
       (TestCBGood = True) and (Memo1.Text <> '');
end;

//RetrievePanel1 MouseDown
procedure TForm1.RetrievePanel1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var hCur: HCURSOR;
begin
     case Button of                   //popup menu at cursor
          mbLeft : begin                                   //   EXIT
                   hCur := LoadCursorFromFile(PChar(ExtractFilePath(Application.ExeName) + 'System\Sight.cur'));
                   Screen.Cursors[1] := hCur;
                   Screen.Cursor := 1;

                   RetrievePanel1.OnMouseDown := nil;  //delimrter
                   end;
     end;
end;

//RetrievePanel1 MouseUp
procedure TForm1.RetrievePanel1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     case Button of                   //popup menu at cursor
          mbLeft : begin                                   //   EXIT
                   Mouse_Event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);  //no positioning needed here
                   Mouse_Event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
                   Application.Minimize;
                   Application.ProcessMessages;

                   RetrieveData();

                   ShowWindow(Form1.Handle, SW_SHOW);   //only this will show form after Hide
                   Form1.BringToFront;

                   Screen.Cursor := crDefault;
                   RetrievePanel1.OnMouseDown := RetrievePanel1MouseDown;
                   end;
     end;
end;

//Return data button
procedure TForm1.RtnData1Click(Sender: TObject);
begin
     Memo1.Text := Memo3.Text;
end;

//===================================================//
//   Send Retrieve Data to/from window section END   //
//===================================================//


initialization
{$I pngs.ctrs}
end.

