unit Unit4;

{$mode objfpc}{$H+}

interface

uses
    Windows, Classes, SysUtils, FileUtil, BGRAButton, Forms, Controls, Graphics, Dialogs,
    ExtCtrls, StdCtrls, Menus;

type

{ TForm2 }

TForm2 = class(TForm)
     Edit1: TEdit;
     KeyListClose1: TBGRAButton;
     Label5: TLabel;
     Memo1: TMemo;
     CopyName1: TMenuItem;
     CopyPublicKey1: TMenuItem;
     DeleteKey1: TMenuItem;
     Panel1: TPanel;
     PopupMenu1: TPopupMenu;

     procedure CopyName1Click(Sender: TObject);
     procedure CopyPublicKey1Click(Sender: TObject);
     procedure DeleteKey1Click(Sender: TObject);
     procedure FormActivate(Sender: TObject);
     procedure KeyListClose1Click(Sender: TObject);
     procedure Memo1Click(Sender: TObject);

     private
     procedure ScrubFile(FileNm : string; const ScrubCnt : integer);
     public
     { public declarations }
end;

var
Form2: TForm2;
    Row : LongInt = -1;

implementation

{$R *.frm}
uses MsgBxDlgUnit1;

{ TForm2 }

procedure TForm2.FormActivate(Sender: TObject);
begin
     Row := -1;
end;

//Scrub file
procedure TForm2.ScrubFile(FileNm : string; const ScrubCnt : integer);  //overwrite FileNm - ScrubCnt num of times
var f : textfile; x, y, ttlBytes, AHandle : integer;
begin
     try

     //get bytes in file
     AHandle := FileOpen(FileNm, fmShareDenyNone);
     ttlBytes := GetFileSize(AHandle, nil);
     FileClose(AHandle);

     //overwrite file data
     for x := 1 to ScrubCnt do begin    //do it ScrubCnt times
         AssignFile(f, FileNm);
         Rewrite(f);

         for y := 1 to ttlBytes do      //do it for each byte of file
             write(f, #255);

         CloseFile(f);
     end;

     except
     end;

//  ScrubFile(Application.Location + '/System/xcreate.bat, 3);
end;

//Copy Name menu item
procedure TForm2.CopyName1Click(Sender: TObject);
begin
     if (Row = -1) or (Row = 0) then begin
        MsgBxDlg1.CentralMessagesRtn(1, 'C*Click on a line first!');  // get key name

        if MsgBxDlg1.CheckModal = mrOK then
           EXIT;                                 //EXIT
     end;

     Edit1.Text := copy(Memo1.Lines.Strings[Row], 1, pos(' ', Memo1.Lines.Strings[Row]) - 1);
     Edit1.SelectAll;
     Edit1.CopyToClipboard;
     Edit1.SelStart := 0;
     Panel1.SetFocus;
     Row := -1;
end;

//Copy Public Key menu item
procedure TForm2.CopyPublicKey1Click(Sender: TObject);
begin
     if (Row = -1) or (Row = 0) then begin
        MsgBxDlg1.CentralMessagesRtn(1, 'C*Click on a line first!');

        if MsgBxDlg1.CheckModal = mrOK then
           EXIT;                                 //EXIT
     end;

     Edit1.Text := copy(Memo1.Lines.Strings[Row], pos('PUBLIC KEY', Memo1.Lines.Strings[0]), 64);  // get key
     Edit1.SelectAll;
     Edit1.CopyToClipboard;
     Edit1.SelStart := 0;
     Panel1.SetFocus;
     Row := -1;
end;

//Delete Key menu item
procedure TForm2.DeleteKey1Click(Sender: TObject);
begin
     if (Row = -1) or (Row = 0) then begin
        MsgBxDlg1.CentralMessagesRtn(1, 'C*Click on a line first!');

        if MsgBxDlg1.CheckModal = mrOK then
           EXIT;                                 //EXIT
     end;

     Edit1.Text := copy(Memo1.Lines.Strings[Row], 1, pos(' ', Memo1.Lines.Strings[Row]) - 1); // get key name

     MsgBxDlg1.CentralMessagesRtn(2, 'C*Delete this key: ' + Edit1.Text);

     if MsgBxDlg1.CheckModal = mrOK then begin
        ScrubFile(Application.Location + '\.UserKeys\' + Edit1.Text, 3);
        DeleteFile(PChar(Application.Location + '\.UserKeys\' + Edit1.Text));
        Memo1.Lines.Delete(Row);
     end;
end;

//Close button
procedure TForm2.KeyListClose1Click(Sender: TObject);
begin
     Close;
end;

//Memo1 Click
procedure TForm2.Memo1Click(Sender: TObject);
begin
     Row := SendMessage(Memo1.Handle, EM_LINEFROMCHAR, Memo1.SelStart, 0);
end;

end.

//--------------------------------------------------------------------------------
//--------------------------------------------------------------------------------
//--------------------------------------------------------------------------------

//     Row := SendMessage(Memo1.Handle, EM_LINEFROMCHAR, Memo1.SelStart, 0);
//     ShowMessage(inttostr(Row));
//     Col := Memo1.SelStart-SendMessage(Memo1.Handle, EM_LINEINDEX, Row, 0);

