unit Unit5;

{$mode delphi}

interface

uses
    Windows, Classes, SysUtils, FileUtil, BGRAButton, Forms, Controls, Graphics, Process,
    StdCtrls, Dialogs;

type

{ TForm3 }

TForm3 = class(TForm)
   CopyName1: TBGRAButton;
   Generate1: TBGRAButton;
   GenerateClose1: TBGRAButton;
   Label2: TLabel;
   Label6: TLabel;
   Label7: TLabel;
   Label8: TLabel;
   Memo1: TMemo;

   UsersPublicKeys1: TEdit;
   UsersKeysName1: TEdit;

   procedure CopyName1Click(Sender: TObject);
   procedure FormActivate(Sender: TObject);
   procedure Generate1Click(Sender: TObject);
   procedure GenerateClose1Click(Sender: TObject);

   private
   procedure ProcessRtn(ProcessLine : string);

   public
   { public declarations }
end;

var
Form3: TForm3;

implementation

{$R *.frm}
uses MsgBxDlgUnit1, Unit4;

{ TForm3 }

//Process
procedure TForm3.ProcessRtn(ProcessLine : string);
var AProcess: TProcess;
begin
     AProcess := TProcess.Create(nil);
     try
       AProcess.ShowWindow := swoHIDE;
       AProcess.Options := [poWaitOnExit];

       AProcess.Executable := ProcessLine;
       AProcess.Execute();
     finally
       AProcess.Free();
     end;
end;

//FormActivate
procedure TForm3.FormActivate(Sender: TObject);
begin
     UsersKeysName1.Text := 'self';
     UsersPublicKeys1.Clear;
end;

//Copy name to clipboard
procedure TForm3.CopyName1Click(Sender: TObject);
begin
     UsersKeysName1.SelectAll;
     UsersKeysName1.CopyToClipboard;
     UsersKeysName1.SelStart := 0;
end;

//Write String To
function WriteStringTo(const FileName: string; data : string): boolean;  {proc-func}
var outfile : text;
begin
     try
       assignfile(outfile, FileName);
       rewrite(outfile);

       write(outfile, data);

       closefile(outfile);
       Result := True;
     except
       Result := False;
     end;
end;

//Generate key
procedure TForm3.Generate1Click(Sender: TObject);   // box-master.exe new-identity -name john
var x : integer; Params, data : string;
begin
     Params := '';

     UsersKeysName1.Text := trim(UsersKeysName1.Text);

     if trim(UsersKeysName1.Text) = '' then    // default to key name 'self'
        UsersKeysName1.Text := 'self';

     //chk if key already exist
     ProcessRtn(Application.Location + 'System/xlist.bat');  // get keys list
     Memo1.Lines.LoadFromFile('ListKeys.txt');

     for x := 0 to Memo1.Lines.Count - 1 do begin
         data := copy(Memo1.Lines.Strings[x], 1, pos(' ', Memo1.Lines.Strings[x]) - 1); // get key name only

         if lowercase(UsersKeysName1.Text) = lowercase(data) then begin   // key names =?
            MsgBxDlg1.ButtonParams('OK', 'Cancel');
            MsgBxDlg1.CentralMessagesRtn(1, 'C*User Identity Key ''' + UsersKeysName1.Text + ''' already exist!  Creation canceled.');
            EXIT;                                 //EXIT
            end;
     end;

     Params := 'box-master.exe new-identity -name ' + UsersKeysName1.Text;  // box-master.exe new-identity -name john

     WriteStringTo(Application.Location + '/System/xcreate.bat', Params);

     ProcessRtn(Application.Location + '/System/xcreate.bat');  // create new User Identity Key

     ProcessRtn(Application.Location + 'System/xlist.bat');  // get keys list again
     Memo1.Lines.LoadFromFile('ListKeys.txt');

     for x := 0 to Memo1.Lines.Count - 1 do begin
         data := copy(Memo1.Lines.Strings[x], 1, pos(' ', Memo1.Lines.Strings[x]) - 1); // get key name only

         if UsersKeysName1.Text = data then   // key names =?
            UsersPublicKeys1.Text := copy(Memo1.Lines.Strings[x], pos('identity  ', Memo1.Lines.Strings[x]) + 10, 100); // put new key into display TEdit
     end;
end;

//Close button
procedure TForm3.GenerateClose1Click(Sender: TObject);
begin
     Close
end;


end.

