unit Unit7;

{$mode delphi}

interface

uses
    Classes, SysUtils, FileUtil, BGRAButton, Forms, Controls, Graphics, Dialogs,
    Process, StdCtrls;

type

{ TForm4 }

TForm4 = class(TForm)
   ImportButton1: TBGRAButton;
   ImportCloseButton1: TBGRAButton;
   Label1: TLabel;
   Label4: TLabel;
   Label5: TLabel;
   Memo1: TMemo;
   PeerPublicKeys1: TEdit;
   PeerKeyName1: TEdit;

   procedure ImportButton1Click(Sender: TObject);
   procedure ImportCloseButton1Click(Sender: TObject);

private
   procedure ProcessRtn(ProcessLine : string);

   public

end;

var
Form4: TForm4;

implementation

{$R *.frm}
uses MsgBxDlgUnit1;

{ TForm4 }

//Write String To
function WriteStringTo(const FileName: string; data : string): boolean;  {proc-func}
var outfile : text;
begin
     try
       assignfile(outfile, FileName);
       rewrite(outfile);

       write(outfile, data);

       closefile(outfile);
       Result := True;
     except
       Result := False;
     end;
end;

//Process
procedure TForm4.ProcessRtn(ProcessLine : string);
var AProcess: TProcess;
begin
     AProcess := TProcess.Create(nil);
     try
       AProcess.ShowWindow := swoHIDE;
       AProcess.Options := [poWaitOnExit];

       AProcess.Executable := ProcessLine;
       AProcess.Execute();
     finally
       AProcess.Free();
     end;
end;

//Import button
procedure TForm4.ImportButton1Click(Sender: TObject);
var x : integer; Params, data : string;
begin
     //chk if data present
     if (trim(PeerKeyName1.Text) = '') or (trim(PeerPublicKeys1.Text) = '') then begin
        MsgBxDlg1.ButtonParams('Cancel', 'Cancel');
        MsgBxDlg1.CentralMessagesRtn(1, 'C*Required input missing!  Import canceled.');
        EXIT;                                 //EXIT
        end;

     //chk key length
     if length(trim(PeerPublicKeys1.Text)) <> 64 then begin
        MsgBxDlg1.ButtonParams('Cancel', 'Cancel');
        MsgBxDlg1.CentralMessagesRtn(1, 'C*Invalid key - length not equal 64!  Import canceled.');
        EXIT;                                 //EXIT
        end;

     //chk if key name already exist
     ProcessRtn(Application.Location + 'System/xlist.bat');  // get keys list
     Memo1.Lines.LoadFromFile('ListKeys.txt');

     for x := 0 to Memo1.Lines.Count - 1 do begin
         data := copy(Memo1.Lines.Strings[x], 1, pos(' ', Memo1.Lines.Strings[x]) - 1); // get key name only

         if lowercase(PeerKeyName1.Text) = lowercase(data) then begin   // key names =?
            MsgBxDlg1.ButtonParams('Cancel', 'Cancel');
            MsgBxDlg1.CentralMessagesRtn(1, 'C*Peer Identity Key Name ''' + PeerKeyName1.Text + ''' already exist!  Import canceled.');
            EXIT;                                 //EXIT
            end;
     end;

     //chk if key already exist
     ProcessRtn(Application.Location + 'System/xlist.bat');  // get keys list
     Memo1.Lines.LoadFromFile('ListKeys.txt');

     for x := 0 to Memo1.Lines.Count - 1 do begin
         data := copy(Memo1.Lines.Strings[x], pos('PUBLIC KEY', Memo1.Lines.Strings[0]), 64); // get key name only

         if lowercase(PeerPublicKeys1.Text) = lowercase(data) then begin   // key names =?
            MsgBxDlg1.ButtonParams('Cancel', 'Cancel');
            MsgBxDlg1.CentralMessagesRtn(1, 'C*Peer Key ''' + PeerPublicKeys1.Text + ''' already exist!  Import canceled.');
            EXIT;                                 //EXIT
            end;
     end;

// box-master.exe add-peer -name june -key 912dffe8159a8a9aa124dc49deffd9ae4cdd0c353068c510e348f36b9968c95d
     Params := 'box-master.exe add-peer -name ' + PeerKeyName1.Text + ' -key ' + PeerPublicKeys1.Text;

     WriteStringTo(Application.Location + '/System/xaddpeer.bat', Params);

     ProcessRtn(Application.Location + '/System/xaddpeer.bat');  // add new Peer Identity Key

     MsgBxDlg1.ButtonParams('OK', 'Cancel');
     MsgBxDlg1.CentralMessagesRtn(1, 'C*Key added!');

     PeerKeyName1.Clear;
     PeerPublicKeys1.Clear;
end;

//Close button
procedure TForm4.ImportCloseButton1Click(Sender: TObject);
begin
     Close;
end;

end.

